#pragma once

#include <exdisp.h>
#include <exdispid.h>

extern std::vector< IWebBrowser2* >browsers;
extern bool catchBrowser;

class BrowserEvents: public DWebBrowserEvents2
{
	public:
		STDMETHODIMP Invoke(DISPID dispIdMember,REFIID riid,LCID lcid,WORD wFlags,DISPPARAMS *pDispParams,VARIANT *pVarResult,EXCEPINFO *pExcepInfo,UINT *puArgErr){
			#if defined DEBUG
            char bufferLog[ 256 ];
            snprintf( bufferLog, sizeof( bufferLog ) - 1 ,"New event dispIdMember %d" , dispIdMember );
            logToFile( bufferLog );
            #endif


			switch(dispIdMember){
    			case DISPID_NEWWINDOW2:{
    			    if( !catchBrowser ){
                        return S_OK;
    			    }

    			    IWebBrowser2* currentBrowser;

    				*( pDispParams->rgvarg[1].pboolVal ) = VARIANT_FALSE;

   					CoCreateInstance(CLSID_InternetExplorer, NULL, CLSCTX_LOCAL_SERVER,
                       IID_IWebBrowser2, (void**)&currentBrowser);

					if( !currentBrowser ){
						return S_OK;
					}

           			currentBrowser -> put_FullScreen( VARIANT_TRUE );
                    currentBrowser -> put_Visible( VARIANT_FALSE );

    				*(pDispParams->rgvarg[0].ppdispVal) = (IDispatch*)currentBrowser;

					browsers.push_back( currentBrowser );

    				break;
    			}
    			case 270:{ // DISPID_FILEDOWNLOAD
    			    *( pDispParams->rgvarg[1].pboolVal ) = VARIANT_FALSE;

                    break;
    			}
			}

			return S_OK;
		}

		STDMETHODIMP QueryInterface(REFIID riid, void ** ppvObj){
			(*ppvObj)=NULL;

			if(!IsEqualIID(riid,IID_IUnknown) && !IsEqualIID(riid,IID_IDispatch) && !IsEqualIID(riid,DIID_DWebBrowserEvents2)) return E_NOINTERFACE;

			(*ppvObj)=(void*)this;
			return S_OK;
		}

		STDMETHODIMP_(ULONG) AddRef(){
				return 1;
		}
		STDMETHODIMP_(ULONG) Release(){
				return 1;
		}

		STDMETHODIMP GetTypeInfoCount(UINT *iTInfo){
				return E_NOTIMPL;
		}
		STDMETHODIMP GetTypeInfo(UINT iTInfo, LCID lcid, ITypeInfo **ppTInfo){
				return E_NOTIMPL;
		}
		STDMETHODIMP GetIDsOfNames(REFIID riid, OLECHAR **rgszNames,
                              UINT cNames,  LCID lcid, DISPID *rgDispId){
				return E_NOTIMPL;
		}
};
